<app-loading *ngIf="isLoading"></app-loading>
<div class="app-card">
  <form nz-form [formGroup]="form">
    <div class="app-row" nz-row [nzGutter]="[30, 0]">
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="name" [mbMaxLength]="150"
          [mbType]="isSubmitted && form.controls['name'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['name'].errors !== null"
          [mbErrors]="form.controls['name'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '150' }},
            { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.permissionConfig.label.name' | translate }}]"
          mbPlaceholderText="--{{'system.permissionConfig.label.name' | translate}}--"
          mbLabelText="{{'system.permissionConfig.label.name' | translate}} <span class='label__required'>*</span>">
        </mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <label class="input__label">{{'system.permissionConfig.label.resources' | translate}} <span class='label__required'>*</span></label>
        <app-choose-function-input  (modelChange)="changeresourceId($event)"  [class.error]="isSubmitted && form.controls['resources'].errors !== null" [(model)]="resourceId" [listFunction]="listResource"></app-choose-function-input>
        <div class="show-error" *ngIf="isSubmitted && form.controls['resources'].errors !== null">
          <em nz-icon nzType="close-circle" nzTheme="outline"></em>
          <span class="text__message">{{'system.validate.requiredResource' | translate}}</span>
        </div>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-select [mbDataSelects]="listResourceType" mbKeyLabel="name" mbKeyValue="code" [mbDisable]="isUpdate"
        [mbType]="isSubmitted && form.controls['type'].errors ? 'error' : 'default'"
        [mbShowError]="isSubmitted && form.controls['type'].errors !== null" [mbErrors]="form.controls['type'].errors"
        [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.permissionConfig.label.type' | translate }}]"
        mbPlaceholder="--{{'system.permissionConfig.label.type' | translate}}--"
        mbLabelText="{{'system.permissionConfig.label.type' | translate}} <span class='label__required'>*</span>"
        formControlName="type"></mb-select>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="description" [mbIsTextAre]='true' [mbConfig]="{autoSize:true, rows:1}" [mbMaxLength]="150"
          [mbType]="isSubmitted && form.controls['description'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['description'].errors !== null" [mbErrors]="form.controls['description'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '150' }}]"
          mbPlaceholderText="--{{'system.permissionConfig.label.description' | translate}}--"
          mbLabelText="{{'system.permissionConfig.label.description' | translate}}"></mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="12" *ngIf="isShowScopes">
        <mb-select-check-able [mbDataSelects]="listScopesOfResource" mbKeyLabel="name" mbKeyValue="code"
          [mbShowAction]="false" [mbShowCheckAll]="listScopesOfResource && listScopesOfResource.length > 0" (mbEventEmit)="emitValue($event)"
          [mbType]="isSubmitted && form.controls['scopes'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['scopes'].errors !== null"
          [mbErrors]="form.controls['scopes'].errors"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.permissionConfig.label.scopes' | translate }}]"
          mbPlaceholder="--{{'system.permissionConfig.label.scopes' | translate}}--"
          mbLabelText="{{'system.permissionConfig.label.scopes' | translate}} <span class='label__required'>*</span>" formControlName="scopes"></mb-select-check-able>
      </div>
      <div nz-col nzXs="24" nzLg="24">
        <div class="input__label">
          <label>{{'system.permissionConfig.label.roleName' | translate}}</label>
        </div>
        <div class="select__group select__group--icon">
          <div class="select__group--group--default">
            <nz-select class="pc-select select__select select__select--one no__icon" nzMode="default" [nzShowSearch]="true"
                     nzPlaceHolder="--{{'system.permissionConfig.label.roleName' | translate}}--" [nzOptionHeightPx]="56" [nzOptionOverflowSize]="5"
                     formControlName="roleName" (ngModelChange)="itemchoose($event)">
              <nz-option class="select__option" *ngFor="let data of listRoleForApply" nzValue="{{data.name}}" nzLabel="{{data.description}}">
              </nz-option>
            </nz-select>
          </div>
        </div>
      </div>
      <div nz-col nzXs="24" nzLg="24">
        <div class="data-table" oncontextmenu="return false;">
          <nz-table #basicTable [nzData]="listRoleSelected" [nzShowPagination]="false" nzTableLayout="fixed" [nzScroll]="{ y: '250px' }" [nzPageSize]="listRoleSelected.length" nzSize='small'>
            <thead>
              <tr class="table-header">
                <th scope="col" nzWidth='60px' nzLeft='0' class="text-nowrap text-center">{{'system.table.stt' | translate}}</th>
                <th scope="col" class="text-nowrap">{{'system.role.label.table.code' | translate}}</th>
                <th scope="col" class="text-nowrap">{{'system.role.label.table.name' | translate}}</th>
                <th scope="col" nzWidth='80px' nzRight='0' class="text-nowrap text-center"></th>
              </tr>
            </thead>
            <tbody>
              <tr class="pc-form-tr-for-class" *ngFor="let data of basicTable.data ;let i = index;">
                <td nzWidth='60px' nzLeft='0'>{{ i + 1 }}</td>
                <td>{{ data?.name }}</td>
                <td>{{ data?.description }}</td>
                <td nzWidth='80px' nzRight='0' class="text-nowrap text-center">
                  <mb-button-icon mbButtonType="DELETE" (click)="deleteRole(data)"> </mb-button-icon>
                </td>
              </tr>
            </tbody>
          </nz-table>
        </div>
      </div>
    </div>
    <div class="footer">
      <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="save()" mbButtonAvailableStyle="PRIMARY"
        mbButtonText="{{'common.button.save' | translate}}"></mb-button>
    </div>
  </form>
</div>
